unit MainFormUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, WaveBase, WaveOut, StdCtrls, CosineTable, ComCtrls, AudioSource,
  UpAudioSource, ExtCtrls, Math, ImgList, ActnList, Buttons, DeviceFormUnit,
  WaveFormUnit, XPMan, AboutFormUnit, Menus;

type
  TMainForm = class(TForm)
    WaveOut1: TWaveOut;
    Timer1: TTimer;
    GroupBox1: TGroupBox;
    TrackBar1: TTrackBar;
    Panel1: TPanel;
    GroupBox2: TGroupBox;
    ProgressBar1: TProgressBar;
    Panel2: TPanel;
    TrackBar2: TTrackBar;
    GroupBox3: TGroupBox;
    Panel3: TPanel;
    TrackBar3: TTrackBar;
    Panel4: TPanel;
    TrackBar4: TTrackBar;
    Panel5: TPanel;
    TrackBar5: TTrackBar;
    GroupBox4: TGroupBox;
    Panel6: TPanel;
    TrackBar6: TTrackBar;
    Panel7: TPanel;
    TrackBar7: TTrackBar;
    Panel8: TPanel;
    TrackBar8: TTrackBar;
    GroupBox5: TGroupBox;
    GroupBox6: TGroupBox;
    PaintBox1: TPaintBox;
    Panel9: TPanel;
    ComboBoxEx1: TComboBoxEx;
    ImageList1: TImageList;
    SpeedButton1: TSpeedButton;
    ActionList1: TActionList;
    ActionStart: TAction;
    ActionStop: TAction;
    ActionConfigure: TAction;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    ActionTest: TAction;
    SpeedButton4: TSpeedButton;
    ActionAbout: TAction;
    MainMenu1: TMainMenu;
    MenuFile: TMenuItem;
    MenuItemSave: TMenuItem;
    MenuDevice: TMenuItem;
    MenuItemTest: TMenuItem;
    MenuItemStartStop: TMenuItem;
    MenuItemConfigure: TMenuItem;
    ActionExport: TAction;
    XPManifest1: TXPManifest;
    SaveDialog1: TSaveDialog;
    MenuHelp: TMenuItem;
    MenuItemAbout: TMenuItem;
    procedure WaveOut1Buffer(Buffer: Pointer; Length: Cardinal;
      BufferQueueLength: Integer);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TrackBarChange(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure ActionStartExecute(Sender: TObject);
    procedure ActionStopExecute(Sender: TObject);
    procedure ActionConfigureExecute(Sender: TObject);
    procedure ActionTestExecute(Sender: TObject);
    procedure WaveOut1Start(Sender: TObject);
    procedure WaveOut1Stop(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ActionAboutExecute(Sender: TObject);
    procedure ActionExportExecute(Sender: TObject);
  private
    FSource:TUpAudioSource;
    FBitmap:TBitmap;
  public
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

{ TForm1 }

procedure TMainForm.WaveOut1Buffer(Buffer: Pointer; Length: Cardinal;
  BufferQueueLength: Integer);
begin
  with WaveOut1 do
    FSource.Render(Buffer,Length,Frequency,Stereo,Bits16);
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  FBitmap:=TBitmap.Create;
  FSource:=TUpAudioSource.Create;
  ComboBoxEx1.ItemIndex:=0;
  TrackBarChange(nil);
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  FreeAndnil(FSource);
  FreeAndNil(FBitmap);
end;

procedure TMainForm.TrackBarChange(Sender: TObject);
begin
  with FSource do begin
    WaveType:=TWaveType(ComboBoxEx1.ItemIndex);
    Volume:=(TrackBar1.Max-TrackBar1.Position)/TrackBar1.Max;
    Panel1.Caption:=Format('%d',[TrackBar1.Max-TrackBar1.Position]);
    Base:=TrackBar3.Position;
    Panel3.Caption:=Format('Frquence minimale: %d Hz',[TrackBar3.Position]);
    Multiplicator:=Power(2,1/TrackBar5.Position);
    Panel5.Caption:=Format('Harmoniques par octave: %d',[TrackBar5.Position]);
    Speed:=TrackBar2.Position/(512*Multiplicator);
    Panel2.Caption:=Format('Vitesse ascensionnelle: %.2f',[TrackBar2.Position/1024]);
    if TrackBar4.Position<=TrackBar3.Position then
      TrackBar4.Position:=TrackBar3.Position+1;
    Waves:=Ceil(Ln(TrackBar4.Position/Base)/Ln(Multiplicator));
    Panel4.Caption:=Format('Frquence maximale: %d Hz',[TrackBar4.Position]);
    FilterMedian:=Ln(TrackBar6.Position/Base)/Ln(Multiplicator);
    Panel6.Caption:=Format('Frquence centrale: %d Hz',[TrackBar6.Position]);
    FilterShape:=TrackBar7.Position/1000;
    Panel7.Caption:=Format('Convexit: %.3f',[FilterShape]);
    FilterWidth:=TrackBar8.Position/1000;
    Panel8.Caption:=Format('Largeur: %.3f',[FilterWidth]);
  end;
end;

procedure TMainForm.Timer1Timer(Sender: TObject);
begin
  PaintBox1Paint(nil);
  ProgressBar1.Position:=Round(ProgressBar1.Max*FSource.Progress);
end;

procedure TMainForm.PaintBox1Paint(Sender: TObject);
begin
  with PaintBox1 do begin
    FBitmap.Width:=ClientWidth;
    FBitmap.Height:=ClientHeight;
    FSource.PaintTo(FBitmap.Canvas,ClientWidth,ClientHeight);
    Canvas.Draw(0,0,FBitmap);
  end;
end;

procedure TMainForm.ActionStartExecute(Sender: TObject);
begin
  WaveOut1.Start;
end;

procedure TMainForm.ActionStopExecute(Sender: TObject);
begin
  WaveOut1.Stop;
end;

procedure TMainForm.ActionConfigureExecute(Sender: TObject);
begin
  DeviceForm.Execute(WaveOut1);
end;

procedure TMainForm.ActionTestExecute(Sender: TObject);
begin
  WaveOut1.Test;
  MessageDlg('Le priphrique semble fonctionner correctement...',mtInformation,[mbOk],0);
end;

procedure TMainForm.WaveOut1Start(Sender: TObject);
begin
  ActionTest.Enabled:=False;
  ActionExport.Enabled:=False;
  SpeedButton2.Glyph:=nil;
  SpeedButton2.Action:=ActionStop;
  MenuItemStartStop.Action:=ActionStop;
end;

procedure TMainForm.WaveOut1Stop(Sender: TObject);
begin
  MenuItemStartStop.Action:=ActionStart;
  SpeedButton2.Glyph:=nil;
  SpeedButton2.Action:=ActionStart;
  ActionExport.Enabled:=True;
  ActionTest.Enabled:=True;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  WaveOut1.Stop;
end;

procedure TMainForm.ActionAboutExecute(Sender: TObject);
begin
  AboutForm.ShowModal;
end;

procedure TMainForm.ActionExportExecute(Sender: TObject);
var
  f:TFileStream;
  Frequency:Cardinal;
  Stereo,Bits16:Boolean;
begin
  if WaveForm.Execute(Frequency,Stereo,Bits16) and SaveDialog1.Execute then begin
    f:=TFileStream.Create(SaveDialog1.FileName,fmOpenWrite or fmCreate);
    try
      FSource.ExportToStream(f,Frequency,Stereo,Bits16);
    finally
      f.Destroy;
    end;
  end;
end;

end.

